import psutil
from re import findall
from subprocess import PIPE, Popen, check_output

class RPI:
    def __init__(self) -> None:
        pass
    @staticmethod
    def get_cpu_temperature():
        temp = check_output(["vcgencmd","measure_temp"]).decode("UTF-8")
        return(findall("\d+\.\d+",temp)[0])
    @staticmethod
    def getserial():
      cpuserial = "0000000000000000"
      try:
        file = open('/proc/cpuinfo','r')
        for line in file:
          if line[0:6]=='Serial':
            cpuserial = line[10:26]
        file.close()
      except:
        cpuserial = "ERROR"

      return cpuserial
    @staticmethod
    def getAll():
        data = {
            "cpu_temp":RPI.get_cpu_temperature(),
            "serial":RPI.getserial(),
            "RAM":{'total':RPI.RAM().total,'used':RPI.RAM().used,'free': RPI.RAM().free,'percent':RPI.RAM().percent},
            "DISK":{'total':RPI.DISK().total,'used':RPI.DISK().used,'free': RPI.DISK().free,'percent':RPI.DISK().percent}
        }
        return data
    class RAM:
        def __init__(self):
            ram = psutil.virtual_memory()
            self.__total = ram.total
            self.__used = ram.used
            self.__free = ram.free
            self.__percent = ram.percent
        
        @property
        def total(self):
            return self.__total
        @property
        def used(self):
            return self.__used
        @property
        def free(self):
            return self.__free
        @property
        def percent(self):
            return self.__percent
    class DISK:
        def __init__(self):
            disk = psutil.disk_usage('/')
            self.__total = disk.total
            self.__used = disk.used
            self.__free = disk.free
            self.__percent = disk.percent
        
        @property
        def total(self):
            return self.__total
        @property
        def used(self):
            return self.__used
        @property
        def free(self):
            return self.__free
        @property
        def percent(self):
            return self.__percent
    